<?
/**
    * A delegate class for the entire application to handle custom handling of
    * some functions such as permissions and preferences.
    */
class conf_ApplicationDelegate {
    /**
        * Returns permissions array.  This method is called every time an action is
        * performed to make sure that the user has permission to perform the action.
        * @param record A Dataface_Record object (may be null) against which we check
        *               permissions.
        * @see Dataface_PermissionsTool
        * @see Dataface_AuthenticationTool
        */
    function getPermissions(&$record){
        $auth =& Dataface_AuthenticationTool::getInstance();
        $user =& $auth->getLoggedInUser();
        if ( !isset($user) ) return Dataface_PermissionsTool::NO_ACCESS();
        // if the user is null then nobody is logged in... no access.
        // This will force a login prompt.
        $role = $user->val('Role');
        return Dataface_PermissionsTool::getRolePermissions($role);
        // Returns all of the permissions for the user's current role.
    }

    /*  
    function getPermissions(&$record){
        // $record is a Dataface_Record object
        $auth =& Dataface_AuthenticationTool::getInstance();
        $user =& $auth->getLoggedInUser();
        if ( $user ) return Dataface_PermissionsTool::ALL();
        else return Dataface_PermissionsTool::NO_ACCESS();
    }
    
    */
    

    /* set default sort order This seems to work for 13x but not 15x. for 15x version use the stanza in index.php */
    function beforeHandleRequest(){
        $app = Dataface_Application::getInstance(); 
        $query =& $app->getQuery();
        if ( !$_POST and $query['-table'] == 'nte_note' and !@$query['-sort'] ){
            $query['-sort'] = 'updatedtime desc';
        }
    }
}
?>
